/*
 * Copyright 1989 O'Reilly and Associates, Inc.
 * See README.ora for complete rights and liability information.
 */

/* 
 * Generic.c - generic composite widget
 */

#include	<X11/IntrinsicP.h>
#include	<X11/StringDefs.h>

#include	"GenericP.h"

#include	<stdio.h>

#define INITIAL_WIDTH 300
#define INITIAL_HEIGHT 300

/****************************************************************
 *
 * scrollBox Resources
 *
 ****************************************************************/

/*static XtResource resources[] = {
    {XtNhSpace, XtCHSpace, XtRDimension, sizeof(Dimension),
	 XtOffset(ScrollBoxWidget, scrollBox.h_space), XtRImmediate, (XtPointer)4},
    {XtNvSpace, XtCVSpace, XtRDimension, sizeof(Dimension),
	 XtOffset(ScrollBoxWidget, scrollBox.v_space), XtRImmediate, (XtPointer)4},
};*/

/****************************************************************
 *
 * Full class record constant
 *
 ****************************************************************/

static void Initialize();
static Boolean SetValues();
static void ChangeManaged();
static XtGeometryResult QueryGeometry(), GeometryManager();

GenericClassRec genericClassRec = {
  {
/* core_class fields      */
    /* superclass         */    (WidgetClass) &compositeClassRec,
    /* class_name         */    "generic",
    /* widget_size        */    sizeof(GenericRec),
    /* class_initialize   */    NULL,
    /* class_part_init    */	NULL,
    /* class_inited       */	FALSE,
    /* initialize         */    Initialize,
    /* initialize_hook    */	NULL,
    /* realize            */    XtInheritRealize,
    /* actions            */    NULL,
    /* num_actions	  */	0,
    /* resources          */    NULL,
    /* num_resources      */    0,
    /* xrm_class          */    NULLQUARK,
    /* compress_motion	  */	TRUE,
    /* compress_exposure  */	TRUE,
    /* compress_enterleave*/	TRUE,
    /* visible_interest   */    FALSE,
    /* destroy            */    NULL,
    /* resize             */    XtInheritResize,
    /* expose             */    NULL,
    /* set_values         */    SetValues,
    /* set_values_hook    */	NULL,
    /* set_values_almost  */    XtInheritSetValuesAlmost,
    /* get_values_hook    */	NULL,
    /* accept_focus       */    NULL,
    /* version            */	XtVersion,
    /* callback_private   */    NULL,
    /* tm_table           */    NULL,
    /* query_geometry     */	QueryGeometry,
    /* display_accelerator*/	XtInheritDisplayAccelerator,
    /* extension          */	NULL
  },{
/* composite_class fields */
    /* geometry_manager   */    GeometryManager,
    /* change_managed     */    ChangeManaged,
    /* insert_child	  */	XtInheritInsertChild,
    /* delete_child	  */	XtInheritDeleteChild,
    /* extension          */	NULL
  },{
/* generic class fields */
    /* empty		  */	0,
  }
};

WidgetClass genericWidgetClass = (WidgetClass)&genericClassRec;


/****************************************************************
 *
 * Private Routines
 *
 ****************************************************************/

/* ARGSUSED */
static XtGeometryResult GeometryManager(widget, request, reply)
     Widget widget;
     XtWidgetGeometry *request, *reply;
{
  Dimension wd, ht, bw;
  Position x, y;

  XtVaGetValues(widget,
		XtNx, &x,
		XtNy, &y,
		XtNwidth, &wd,
		XtNheight, &ht,
		XtNborderWidth, &bw,
		NULL);

  x = request->request_mode & CWX ? request->x : x;
  y = request->request_mode & CWY ? request->y : y;
  wd = request->request_mode & CWWidth ? request->width : wd;
  ht = request->request_mode & CWHeight ? request->height : ht;
  bw = request->request_mode & CWBorderWidth ? request->border_width : bw;

  XtConfigureWidget(widget, x, y, wd, ht, bw);
  return XtGeometryDone;
}


/* ARGSUSED */
static XtGeometryResult QueryGeometry(w, request, reply_return)
Widget w;
XtWidgetGeometry *request, *reply_return;
{
  return XtGeometryYes;

/*  XtGeometryResult result;

  request->request_mode &= CWWidth | CWHeight;

  if (request->request_mode == 0)
    return XtGeometryYes;

  if (request->request_mode & CWHeight)
    if (request->height < INITIAL_HEIGHT)
      {
	result = XtGeometryAlmost;
	reply_return->height = INITIAL_HEIGHT;
	reply_return->request_mode &= CWHeight;
      }
    else
      result = XtGeometryYes;

  if (request->request_mode & CWWidth)
    if (request->width < INITIAL_WIDTH)
      {
	result = XtGeometryAlmost;
	reply_return->width = INITIAL_WIDTH;
	reply_return->request_mode &= CWWidth;
      }
    else
      result = XtGeometryYes;

  return(result);*/
}



static void ChangeManaged(w)
     GenericWidget w;
{
/*	ScrollBoxWidget sbw = (ScrollBoxWidget) w;
    DoLayout(sbw, True);*/
}

/* ARGSUSED */
static void Initialize(request, new)
     Widget request, new;
{
/*  GenericWidget newgw = (GenericWidget)new;

  if (newgw->core.width == 0)
    newgw->core.width = INITIAL_WIDTH;

  if (newgw->core.height == 0)
    newgw->core.height = INITIAL_HEIGHT;
*/
}

/* ARGSUSED */
static Boolean SetValues(Widget w1, Widget w2, Widget w3,
			 ArgList args, Cardinal *num_args)
{
  return False;
}
