/*
 * Copyright 1989 O'Reilly and Associates, Inc.
 * See README.ora for complete rights and liability information.
 */

/* 
 * GenericP.h - Private definitions for generic composite widget
 * 
 */

#ifndef _XBGenericP_h
#define _XBGenericP_h

#include "Generic.h"

#include <X11/CompositeP.h>

/* New fields for the generic widget class record */
typedef struct _GenericClass {
	int empty;
} GenericClassPart;

/* Full class record declaration */
typedef struct _GenericClassRec {
    CoreClassPart	core_class;
    CompositeClassPart  composite_class;
    GenericClassPart	generic_class;
} GenericClassRec;

extern GenericClassRec genericClassRec;

/* New fields for the generic widget record */
typedef struct {
  int empty;
} GenericPart;


/****************************************************************
 *
 * Full instance record declaration
 *
 ****************************************************************/

typedef struct _ScrollBoxRec {
    CorePart	    core;
    CompositePart   composite;
    GenericPart     generic;
} GenericRec;

#endif /* _XBGenericP_h */
