
/*
DeckView - A browser for Postscript documents.
Version 1.0, BETA 1

Copyright (C) 1996  Adam Ginsburg
Design by Adam Ginsburg, Joe Marks, and Stuart M. Shieber

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

Author: Adam Ginsburg
	Aiken G-20
	33 Oxford Street
	Cambridge, MA 02138 USA

Comments and bug reports to:
	deckview@eecs.harvard.edu
*/



#include "ReducedObj.h"


#define	THIS	ReducedObj
#define	BASE	Object
#define	BASE_CLASSES BASE::desc()
#define	MEMBER_CLASSES
#define VIRTUAL_BASE_CLASSES

DEFINE_CLASS(ReducedObj,1,"$Header: /a/cellar62/home/ginsburg/browser/RCS/ReducedObj.C,v 2.0 1996/03/13 20:49:42 ginsburg Exp $",NULL)

#ifdef FULL_NIHCL
const Class* ReducedObj::species() const
// Return a pointer to the descriptor of the species of this class
{
  return &classDesc;
}
#endif

bool ReducedObj::isEqual(const Object& p) const
// Test two objects for equality
{
#ifdef FULL_NIHCL
  return p.isSpecies(classDesc) && *this==castdown(p);
#else
  return this == &p;
#endif
}


#ifdef FULL_NIHCL
int ReducedObj::compare(const Object&p) const
#else
int ReducedObj::compare(const Object&) const
#endif
// Compare two objects.  If *this > p return >0,
// *this == p return 0, and if *this < p return <0.
{
#ifdef FULL_NIHCL
  assertArgSpecies(p,classDesc,"compare");
#endif
  return 0;
}

#ifdef FULL_NIHCL
void ReducedObj::printOn(ostream& strm) const
// Print this object on an ostream
{
  strm << "Reduced object";
}

// Object I/O

// Construct an object from OIOin "strm".
ReducedObj::ReducedObj(OIOin& strm)
:BASE(strm)
{
}

void ReducedObj::storer(OIOout&) const
// Store the member variables of this object on OIOout "strm".
{
}

// Construct an object from file descriptor "fd".
ReducedObj::ReducedObj(OIOifd& fd)
:BASE(fd)
{
}

void ReducedObj::storer(OIOofd&) const
// Store an object on file descriptor "fd".
{
}
#endif
