/*
DeckView - A browser for Postscript documents.
Version 1.0, BETA 1

Copyright (C) 1996  Adam Ginsburg
Design by Adam Ginsburg, Joe Marks, and Stuart M. Shieber

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

Author: Adam Ginsburg
	Aiken G-20
	33 Oxford Street
	Cambridge, MA 02138 USA

Comments and bug reports to:
	deckview@eecs.harvard.edu
*/

// This is file browser.C

#include "TopShell.h"


static char *help_args[] = {"-?", "-h", "-help"};


Boolean match_string(char *str)
{
  for (int i = 0; i < XtNumber(help_args); i++)
    if (strcmp(help_args[i], str) == 0)
      return True;

  return False;
}


void print_syntax()
{
  cerr << "DeckView syntax:" << endl;
  cerr << endl;
  cerr << "\tdeckview [options] [files]" << endl;
  cerr << endl;
  cerr << "where [options] include X Toolkit options and the following:" << endl;
  cerr << "\t-help\t\tPrint this message" << endl;
  cerr << "\t-antialias (+antialias)\tDisable (enable) thumbnail antialiasing" << endl;
  cerr << "\t-gs path\tSpecify the path to a Ghostscript interpreter" << endl;
  cerr << "\t-dpi num\tSpecify the resolution for thumbnail rendering, e.g. \"-dpi 12\"" << endl;
}


int main(int argc, char **argv)
{
  if ((argc == 2) && match_string(argv[1]))
    {
      print_syntax();
      exit(0);
    }

  TopShell topshell = TopShell(argc, argv);

  topshell.main_loop();
}
