/* Object.c -- implementation of class Object
DeckView NIHCL subset
Version 1.0, BETA 1  (November, 1996)

This file is based on the NIH Class Library, but may incorporate some
changes from the original.  The full NIHCL is available via anonymous
FTP from alw.nih.gov, in directory /pub/NIHCL.  DeckView includes only
the small subset of the Library which is directly employed; the
distributed version is far more comprehensive.  See the README.nihcl
file for details.  The original copyright notice is retained below.

These changes are free software; you can redistribute them and/or
modify them under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

These changes are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

Changes are:
Copyright (C) 1996  Adam Ginsburg

Author: Adam Ginsburg
	Aiken G-20
	33 Oxford Street
	Cambridge, MA 02138 USA

Comments and bug reports to:
	deckview@eecs.harvard.edu


The original file is copyrighted as follows:


	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Bg. 12A, Rm. 2033
	Computer Systems Laboratory
	Division of Computer Research and Technology
	National Institutes of Health
	Bethesda, Maryland 20892
	Phone: (301) 496-1111
	uucp: uunet!nih-csl!kgorlen
	Internet: kgorlen@alw.nih.gov
	September, 1985

Function:

Operations applicable to all objects.
	
$Log:	Object.c,v $
 * Revision 3.12  92/07/26  14:33:04  sandy
 * include directive in form '#include <nihcl/foo.h>'
 * 
 * Revision 3.11  92/04/30  15:49:01  sandy
 * one initor in DEFINE_CLASS macros
 * 
 * Revision 3.10  91/02/18  21:07:39  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.4  91/02/07  11:34:58  kgorlen
 * Change argument to _deepenVBase() to const void*.
 * 
 * Revision 3.3  91/02/05  13:14:42  kgorlen
 * Eliminate reference to NIHCL_NOISA.
 * 
 * Revision 3.2  90/11/15  14:28:54  kgorlen
 * Compile Class::_deepenVBase only if MI defined.
 * Remove Object I/O related members from Class;
 * inherit from ReadFromTbl and StoreOnTbl instead.
 * 
 * Revision 3.1  90/11/10  20:37:27  kgorlen
 *  Fix deepCopy() to correctly handle nil pointer.
 * 
 * Revision 3.0  90/05/20  00:20:35  kgorlen
 * Release for 1st edition.
 * 
*/

#include <ctype.h>
#include <string.h>
#include <nihcl/Object.h>

unsigned Object::size() const { return 0; }

unsigned Object::capacity() const { return 0; }

// error reporting 

void Object::derivedClassResponsibility(const char* fname) const
{
  cerr << "Derived class responsibility: " << fname << endl;
}

void Object::shouldNotImplement(const char* fname) const
{
  cerr << "Should not implement: " << fname << endl;
}

