#ifndef	RANGE_H
#define	RANGE_H

/*$Header: /afs/alw.nih.gov/system/src/local/nihcl/311/share/lib/RCS/Range.h,v 3.11 92/07/26 14:33:29 sandy Exp $*/

/* Range.h -- header file for class Range
DeckView NIHCL subset
Version 1.0, BETA 1  (November, 1996)

This file is based on the NIH Class Library, but may incorporate some
changes from the original.  The full NIHCL is available via anonymous
FTP from alw.nih.gov, in directory /pub/NIHCL.  DeckView includes only
the small subset of the Library which is directly employed; the
distributed version is far more comprehensive.  See the README.nihcl
file for details.  The original copyright notice is retained below.

These changes are free software; you can redistribute them and/or
modify them under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

These changes are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

Changes are:
Copyright (C) 1996  Adam Ginsburg

Author: Adam Ginsburg
	Aiken G-20
	33 Oxford Street
	Cambridge, MA 02138 USA

Comments and bug reports to:
	deckview@eecs.harvard.edu


The original file is copyrighted as follows:


	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	C. J. Eppich
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

$Log:	Range.h,v $
 * Revision 3.11  92/07/26  14:33:29  sandy
 * include directive in form '#include <nihcl/foo.h>'
 * 
 * Revision 3.10  91/02/18  21:08:04  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.0  90/05/20  00:20:57  kgorlen
 * Release for 1st edition.
 * 
*/

#include <nihcl/Object.h>

class Range: public VIRTUAL Object {
	DECLARE_MEMBERS(Range);
	int first,len;
public:
	Range()			{ first = 0; len = -1; }
	Range(int f, int l)	{ first = f; len = l; }
	int length() const	{ return len; }
	int length(int l)	{ return len = l; }
	int firstIndex() const	{ return first; }
	int firstIndex(int f)	{ return first = f; }
	int lastIndex() const	{ return (first + len - 1); }
	int lastIndex(int i)	{ len = i - first + 1;  return i; }
	bool valid() const	{ return (len >= 0); }
	void operator=(const Range& r)  { first = r.first;  len = r.len; }
	bool operator==(const Range& r) const { return ((first == r.first) && (len == r.len)); }
	bool operator!=(const Range& r)	const { return !(*this==r); }
	virtual unsigned hash() const;
	virtual bool isEqual(const Object&) const;
private:			    // shouldNotImplement()
	virtual int compare(const Object&) const;
};

#endif
