#ifndef	SORTEDCLTN_H
#define	SORTEDCLTN_H

/*$Header: /afs/alw.nih.gov/system/src/local/nihcl/311/share/lib/RCS/SortedCltn.h,v 3.11 92/07/26 14:33:46 sandy Exp $*/

/* SortedCltn.h -- declarations for sorted collection
DeckView NIHCL subset
Version 1.0, BETA 1  (November, 1996)

This file is based on the NIH Class Library, but may incorporate some
changes from the original.  The full NIHCL is available via anonymous
FTP from alw.nih.gov, in directory /pub/NIHCL.  DeckView includes only
the small subset of the Library which is directly employed; the
distributed version is far more comprehensive.  See the README.nihcl
file for details.  The original copyright notice is retained below.

These changes are free software; you can redistribute them and/or
modify them under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

These changes are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

Changes are:
Copyright (C) 1996  Adam Ginsburg

Author: Adam Ginsburg
	Aiken G-20
	33 Oxford Street
	Cambridge, MA 02138 USA

Comments and bug reports to:
	deckview@eecs.harvard.edu


The original file is copyrighted as follows:


	THIS SOFTWARE FITS THE DESCRIPTION IN THE U.S. COPYRIGHT ACT OF A
	"UNITED STATES GOVERNMENT WORK".  IT WAS WRITTEN AS A PART OF THE
	AUTHOR'S OFFICIAL DUTIES AS A GOVERNMENT EMPLOYEE.  THIS MEANS IT
	CANNOT BE COPYRIGHTED.  THIS SOFTWARE IS FREELY AVAILABLE TO THE
	PUBLIC FOR USE WITHOUT A COPYRIGHT NOTICE, AND THERE ARE NO
	RESTRICTIONS ON ITS USE, NOW OR SUBSEQUENTLY.

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

$Log:	SortedCltn.h,v $
 * Revision 3.11  92/07/26  14:33:46  sandy
 * include directive in form '#include <nihcl/foo.h>'
 * 
 * Revision 3.10  91/02/18  21:08:23  kgorlen
 * Release for 3rd printing of 1st edition.
 * 
 * Revision 3.1  90/11/10  21:47:01  kgorlen
 * Eliminate operator=() and operator!=().
 * Eliminate first argument of findIndexOfFirstKey() and
 * findIndexOfLastKey().
 * 
 * Revision 3.0  90/05/20  00:21:26  kgorlen
 * Release for 1st edition.
 * 
*/

#include <nihcl/OrderedCltn.h>
#include <nihcl/Range.h>

class SortedCltn: public OrderedCltn {
	DECLARE_MEMBERS(SortedCltn);
public:
	SortedCltn(unsigned size =DEFAULT_CAPACITY);
	virtual Object* add(Object&);
	int findIndexOf(const Object& key) const;
	virtual unsigned occurrencesOf(const Object&) const;
	Range findRangeOf(const Object& key) const;
	Object* remove(const Object&);
protected:
	int findIndexOfFirstKey(int) const;
	int findIndexOfLastKey(int) const;
private:				// shouldNotImplement()
	virtual Object* addAfter(const Object& ob, Object& newob);
	virtual Object* addAllLast(const OrderedCltn&);
	virtual Object* addBefore(const Object& ob, Object& newob);
	virtual Object* addLast(Object& ob);
	virtual void atAllPut(Object& ob);
	virtual int indexOfSubCollection(const SeqCltn& cltn, int start=0) const;
	virtual void replaceFrom(int start, int stop, const SeqCltn& replacement, int startAt =0);
	virtual void sort();
};

#endif
